# TEMPLATE - WEM Publicando Dados em MQTT 

O WEM ["WEG Energy Management"](https://www.weg.net/institutional/BR/pt/solutions/digital-solutions/wem) é um software de gerenciamento do consumo de recursos, como energia elétrica, água, gás, ar comprimido e combustíveis, para aplicações industriais, comerciais e até mesmo condomínios. 

Os dados são coletados por dispositivos de medição de energia e utilidades e são armazenados em um servidor "on premisse", ou seja, em uma instalação interna, local.
Muitas vezes existe a necessidade de levar estes dados para diversos consumidores, por exemplo, gestores de áreas produtivas e manutenção.

A platafora WEGnology será esta "ponte" que levará estes dados de medições do chão de fábrica.
Disponibilizando a informação através de um acesso simplificado via web.

Isto é possível utilizando um módulo fará do WEM um cliente MQTT da Plataforma WEGnology.

## Descrição 

Esse modelo implementa os passos do [guia de conexão](https://files.wnology.io/~losant-application-templateWemPublicandoDadosEmMqtt-0~/MQTT%20WEM%20-%20Guia%20de%20Conex%C3%A3o%20ao%20WEGnology.pdf) referentes ao WEGnology e
fornece os componentes básicos para que uma aplicação possa receber dados via MQTT publicados pelo WEM, sendo eles: [*device gateway*](https://docs.app.wnology.io/devices/gateways-peripherals/#reporting-state-for-peripheral),
[*device peripheral*](https://docs.app.wnology.io/devices/gateways-peripherals/#peripherals), [*access key*](https://docs.app.wnology.io/applications/access-keys/) e
também [*dashboard*](https://docs.app.wnology.io/dashboards/overview/) para que os dados recebidos possam ser melhor apresentados.

## Componentes Chaves 

* DEVICE [*Gateway WEM*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices/~losant-device-gatewayWem-0~/properties): É o dispositivo através do qual o WEM enviará os dados, e que irá direcionar
as publicações para os dispositivos periféricos que devem recebê-las. O campo "*Client ID*" solicitado no WEM deve ser preenchido com o ID deste dispositivo;
* DEVICE [*Periférico de Recebimento WEM*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices/~losant-device-perifericoDeRecebimentoWem-1~/properties): 
É o dispositivo que estocará de fato as informações. Ele receberá os dados através do *gateway* previamente configurado, os nomes dos seus atributos devem ser iguais aos presentes no WEM;
* ACCESS KEY: A chave de acesso permitirá a conexão segura entre o WEM e a plataforma WEGnology. Sem ela configurada, não será possível realizar as publicações MQTT;
* DASHBOARD [*Dados WEM*](https://console.app.wnology.io/dashboards/~losant-dashboard-dadosWem-0~): É no dashboard que são apresentados os dados vindos do WEM, 
cada bloco precisa referenciar o atributo equivalente do periférico, por exemplo, para mostrar a temperatura o bloco precisa ser relacionado com o atributo "Temperature";

## Configuração 

1. Os dados recebidos serão armazenados nos atributos do [*Periférico de Recebimento WEM*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices/~losant-device-perifericoDeRecebimentoWem-1~/attributes),
então adicione os atributos que deseja receber e os nomeie utilizando a mesma grafia que os presentes no WEM; 
2. Só é possível obter a senha de acesso de uma *Access Key* quando a mesma é gerada, por tanto, siga esses passos para gerar a sua:
    - Navegue até [*Access Key*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/access-keys);
    - No canto superior direito, clique em "Add Access Key";
    - Na tela de cadastro, escolha a opção "Allow only the following devices to connect...";
    - Selecione o [*Gateway WEM*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices/~losant-device-gatewayWem-0~/properties);
    - Para finalizar o cadastro, clique em "Create Access Key" na parte inferior da tela;
    - Certifique-se de guardar as chaves em um lugar de fácil acesso, pois a comunicação não acontecerá sem elas.
3. A partir desse ponto os passos seguintes precisam ser realizados no WEM, para isso, consulte o [guia de conexão](https://files.wnology.io/~losant-application-templateWemPublicandoDadosEmMqtt-0~/MQTT%20WEM%20-%20Guia%20de%20Conex%C3%A3o%20ao%20WEGnology.pdf).

Após finalizar as configurações no WEGnology e no WEM, os dados já estarão sendo publicados em MQTT e serão recebidos pelo [*Gateway WEM*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices/~losant-device-gatewayWem-0~/properties), esse que deve
aparecer na tela de [*devices*](https://console.app.wnology.io/applications/~losant-application-templateWemPublicandoDadosEmMqtt-0~/devices) como "conectado" com o símbolo em verde.

## Documentação Auxiliar 

* Como já citado, a configuração acontece em duas etapas e esse modelo contempla apenas a parte referente a plataforma WEGnology. Para realizar as configurações no WEM consulte o [guia de conexão](https://files.wnology.io/~losant-application-templateWemPublicandoDadosEmMqtt-0~/MQTT%20WEM%20-%20Guia%20de%20Conex%C3%A3o%20ao%20WEGnology.pdf).

## Sobre 

Este modelo está em sua versão 1.0.0

Para esclarecer qualquer dúvida, recomendamos o uso do [fórum](https://forums.app.wnology.io/).

Copyright © 2021 WEG SA. Todos os direitos reservados.

Licenciado sob a licença MIT.

https://www.weg.net